#!/usr/bin/python
# coding:utf-8

import RPi.GPIO as GPIO
import lcd
import time
import os

LL = 23 #left_led_num
CL = 19 #center_led_num
RL = 5 #right_led_num

LA = 14 #left_rot_num
LB = 15 #left_rot_num
CA = 12 #center_rot_num
CB = 16 #center_rot_num
RA = 20 #right_rot_num
RB = 21 #right_rot_num

LS = 18 #left_sw_num
CS = 26 #center_sw_num
RS = 11 #right_sw_num

LF = 13 #left_foot_num
RF = 6 #right_foot_num

Ro_time = 0.2 #smaller for slow change

fx_n_file = open("fx_n.txt") 
fx_n = int(fx_n_file.read()) #fx_number
fx_n_file.close()
fx_n_max = 2

n = 1 #value_change
tt = time.time()
page = 0
fx_p = ["a","b","c","3","4","5","6","7","8","9","10"]

GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)

GPIO.setup(LL,GPIO.OUT)
GPIO.setup(CL,GPIO.OUT)
GPIO.setup(RL,GPIO.OUT)

GPIO.setup(LA,GPIO.IN)
GPIO.setup(LB,GPIO.IN)
GPIO.setup(CA,GPIO.IN)
GPIO.setup(CB,GPIO.IN)
GPIO.setup(RA,GPIO.IN)
GPIO.setup(RB,GPIO.IN)
GPIO.setup(LS,GPIO.IN)
GPIO.setup(CS,GPIO.IN)
GPIO.setup(RS,GPIO.IN)
GPIO.setup(LF,GPIO.IN)
GPIO.setup(RF,GPIO.IN)

lcd.lcd_init()
lcd.lcd_string("RasPd1",lcd.LCD_LINE_1)
lcd.lcd_string("      by KGboxes",lcd.LCD_LINE_2)
time.sleep(1)

#volume adjustment
#os.system("amixer cset numid=3 off ; amixer cset numid=4 0 ; amixer cset numid=7 on") 
#os.system("amixer cset numid=8 18 ; amixer cset numid=9 off ; amixer cset numid=5 on ; amixer cset numid=6 37")

def open_fx():
    global page
    global fx_p
    os.system("pd " + str(fx_n) + ".pd &")
    fx_n_file_w = open ("fx_n.txt", 'w')
    fx_n_file_w.write(str(fx_n))
    fx_n_file_w.close
    fx_p_file = open(str(fx_n)+".txt")
    fx_p = fx_p_file.read().splitlines()
    fx_p_file.close()
    # fx_p[0] #name0
    # fx_p[1] #name1
    # fx_p[2] #name2
    fx_p[3] = int(fx_p[3]) #left  foot pdsend3003
    fx_p[4] = int(fx_p[4]) #right foot 3004
    fx_p[5] = int(fx_p[5]) #left   rot page0 3005
    fx_p[6] = int(fx_p[6]) #center rot page0 3006
    fx_p[7] = int(fx_p[7]) #right  rot page0 3007
    fx_p[8] = int(fx_p[8]) #left   rot page1 3008
    fx_p[9] = int(fx_p[9]) #center rot page1 3009
    fx_p[10]= int(fx_p[10])#right  rot page1 3010
    page = 0
    lcd.lcd_init()
    lcd1()
    lcd2()
    if fx_p[3] == 1:
        GPIO.output(LL, 1)
    else:
        GPIO.output(LL, 0)
    if fx_p[4] == 1:
        GPIO.output(CL, 1)
    else:
        GPIO.output(CL, 0)
    time.sleep(0.1)
    for j in range(3,11):
        os.system("echo '"+ str(fx_p[j]) +";' |  pdsend 30"+ str(j).zfill(2))

def close_fx():
    fx_p_file = open (str(fx_n)+".txt", 'w')
    for i in range(11):
        fx_p_file.write(str(fx_p[i])+"\n")
    fx_p_file.close
    os.system("killall pd")

def lcd1():
    if page == 0:
        lcd.lcd_string(fx_p[0],lcd.LCD_LINE_1)
    else:
        lcd.lcd_string(fx_p[2],lcd.LCD_LINE_1)

def lcd2():
    if page == 0:
        lcd.lcd_string(fx_p[1]+str(fx_p[5]).center(4)+str(fx_p[6]).center(4)+str(fx_p[7]).center(4),lcd.LCD_LINE_2)
    else:
        lcd.lcd_string(fx_p[1]+str(fx_p[8]).center(4)+str(fx_p[9]).center(4)+str(fx_p[10]).center(4),lcd.LCD_LINE_2)

def rot(p,Ap,Bp):
    global fx_p
    global tt
    global n
    prefxp = fx_p[p]
    Last_Bs = GPIO.input(Bp) #B_status
    for m in range(0,1000):
        if GPIO.input(Ap) == 1:
            break
        time.sleep(0.0001)
    if (Last_Bs == 0) and (GPIO.input(Bp) == 1):
        fx_p[p] = fx_p[p] - n
    if (Last_Bs == 1) and (GPIO.input(Bp) == 0):
        fx_p[p] = fx_p[p] + n
    if fx_p[p] > 100:
        fx_p[p] = 100
    if fx_p[p] < 0:
        fx_p[p] = 0
    if (prefxp != fx_p[p]):
        if (time.time()-tt) < Ro_time:
            n = 3*n
            if n > 15:
                n = 15
        else:
            n = 1
        tt = time.time()
        lcd2()
        os.system("echo '"+ str(fx_p[p]) +";' |  pdsend 30"+ str(p).zfill(2))

def rotL(channel):
    if page == 0 :
        rot(5,LA,LB)
    else:
        rot(8,LA,LB)
def rotC(channel):
    if page == 0 :
        rot(6,CA,CB)
    else:
        rot(9,CA,CB)
def rotR(channel):
    if page == 0 :
        rot(7,RA,RB)
    else:
        rot(10,RA,RB)

def swL(channel):
    global fx_n
    close_fx()
    fx_n = fx_n - 1
    if fx_n < 0:
        fx_n = fx_n_max
    open_fx()

def swC(channel):
    global fx_n
    close_fx()
    fx_n = fx_n + 1
    if fx_n > fx_n_max:
        fx_n = 0
    open_fx()

def swR(channel):
    global page
    GPIO.output(RL, 1)
    time.sleep(0.03)
    GPIO.output(RL, 0)
    page = page + 1
    if page > 1:
        page = 0
    lcd.lcd_init()
    lcd1()
    lcd2()
    SD = 0
    while (GPIO.input(RS) == 0):
        time.sleep(0.3)
        lcd.lcd_init()
        lcd.lcd_string("Shutdown...",lcd.LCD_LINE_1)
        SD = SD + 1
        if SD == 10:
            shutdown()
            break

def footL(channel):
    global fx_p
    fx_p[3] = fx_p[3] + 1
    if fx_p[3] > 1:
        fx_p[3] = 0
    os.system("echo '"+ str(fx_p[3]) +";' |  pdsend 3003")
    if fx_p[3] == 1:
        GPIO.output(LL, 1)
    else:
        GPIO.output(LL, 0)

def footR(channel):
    global fx_p
    fx_p[4] = fx_p[4] + 1
    if fx_p[4] > 1:
        fx_p[4] = 0
    os.system("echo '"+ str(fx_p[4]) +";' |  pdsend 3004")
    if fx_p[4] == 1:
        GPIO.output(CL, 1)
    else:
        GPIO.output(CL, 0)

def shutdown():
    close_fx()
    lcd.lcd_init()
    lcd.lcd_string("Goodbye!",lcd.LCD_LINE_1)
    GPIO.cleanup()
    os.system("sudo shutdown -h now")

#main
GPIO.add_event_detect(LA,GPIO.FALLING,callback=rotL,bouncetime=10)
GPIO.add_event_detect(CA,GPIO.FALLING,callback=rotC,bouncetime=10)
GPIO.add_event_detect(RA,GPIO.FALLING,callback=rotR,bouncetime=10)
GPIO.add_event_detect(LS,GPIO.FALLING,callback=swL,bouncetime=600)
GPIO.add_event_detect(CS,GPIO.FALLING,callback=swC,bouncetime=600)
GPIO.add_event_detect(RS,GPIO.FALLING,callback=swR,bouncetime=600)
GPIO.add_event_detect(LF,GPIO.FALLING,callback=footL,bouncetime=400)
GPIO.add_event_detect(RF,GPIO.FALLING,callback=footR,bouncetime=400)
open_fx()
try:
    while True:
        time.sleep(10000)
finally:
    lcd.lcd_init()
    GPIO.cleanup()

